(function() {
    var gen1_continuationOrDefault = function(args) {
        var c = args[args.length - 1];
        if (c instanceof Function) {
            return c;
        } else {
            return function(error, result) {
                if (error) {
                    throw error;
                } else {
                    return result;
                }
            };
        }
    };
    var gen2_asyncIf = function(condition, thenBody, cb) {
        if (condition) {
            try {
                thenBody(cb);
            } catch (ex) {
                cb(ex);
            }
        } else {
            cb();
        }
    };
    var gen3_asyncIfElse = function(condition, thenBody, elseBody, cb) {
        if (condition) {
            try {
                thenBody(cb);
            } catch (ex) {
                cb(ex);
            }
        } else {
            try {
                elseBody(cb);
            } catch (ex) {
                cb(ex);
            }
        }
    };
    var gen4_rethrowErrors = function(continuation, block) {
        return function(error, result) {
            if (error) {
                return continuation(error);
            } else {
                try {
                    return block(result);
                } catch (ex) {
                    return continuation(ex);
                }
            }
        };
    };
    var self = this;
    var fs, path, pogo, argv, findParentDirectoryWhere, findQo, defineTasks, isFunctionAsynchronous, parseArgs, runTaskFromWithArgs, displayTasks;
    fs = require("fs");
    path = require("path");
    pogo = require("pogo");
    argv = require("optimist").argv;
    findParentDirectoryWhere = function(predicate, continuation) {
        var gen5_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
        continuation = gen1_continuationOrDefault(arguments);
        predicate = gen5_arguments[0];
        var findParentWhere;
        findParentWhere = function(dir, p, continuation) {
            var gen6_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
            continuation = gen1_continuationOrDefault(arguments);
            dir = gen6_arguments[0];
            p = gen6_arguments[1];
            return p(dir, gen4_rethrowErrors(continuation, function(gen7_asyncResult) {
                return gen3_asyncIfElse(!gen7_asyncResult, function(continuation) {
                    var gen8_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                    continuation = gen1_continuationOrDefault(arguments);
                    var newDir;
                    newDir = path.normalize(path.join(dir, ".."));
                    return gen2_asyncIf(dir !== "/", function(continuation) {
                        var gen9_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                        continuation = gen1_continuationOrDefault(arguments);
                        return findParentWhere(newDir, p, continuation);
                    }, continuation);
                }, function(continuation) {
                    var gen10_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                    continuation = gen1_continuationOrDefault(arguments);
                    return continuation(void 0, dir);
                }, continuation);
            }));
        };
        return findParentWhere(process.cwd(), predicate, continuation);
    };
    findQo = function(continuation) {
        var gen11_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
        continuation = gen1_continuationOrDefault(arguments);
        return findParentDirectoryWhere(function(dir, continuation) {
            var gen12_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
            continuation = gen1_continuationOrDefault(arguments);
            dir = gen12_arguments[0];
            fs.exists(path.join(dir, "qo.pogo"), function(e) {
                continuation(void 0, e);
            });
        }, gen4_rethrowErrors(continuation, function(gen13_asyncResult) {
            var foundDir;
            foundDir = gen13_asyncResult;
            if (foundDir) {
                return continuation(void 0, path.join(foundDir, "qo.pogo"));
            } else {
                continuation();
            }
        }));
    };
    defineTasks = function() {
        var tasks;
        tasks = {};
        global.task = function(name, $function, gen14_options) {
            var self = this;
            var description, desc;
            description = gen14_options !== void 0 && Object.prototype.hasOwnProperty.call(gen14_options, "description") && gen14_options.description !== void 0 ? gen14_options.description : void 0;
            desc = gen14_options !== void 0 && Object.prototype.hasOwnProperty.call(gen14_options, "desc") && gen14_options.desc !== void 0 ? gen14_options.desc : void 0;
            return tasks[name] = {
                "function": $function,
                description: desc || description,
                name: name
            };
        };
        return tasks;
    };
    isFunctionAsynchronous = function(f) {
        return /function(.*continuation)/.test(f.toString());
    };
    parseArgs = function() {
        var args, s;
        args = argv._.slice(0);
        for (s in argv) {
            (function(s) {
                if (argv.hasOwnProperty(s)) {
                    args[s] = argv[s];
                }
            })(s);
        }
        return args;
    };
    runTaskFromWithArgs = function(name, tasks, args, continuation) {
        var gen15_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
        continuation = gen1_continuationOrDefault(arguments);
        name = gen15_arguments[0];
        tasks = gen15_arguments[1];
        args = gen15_arguments[2];
        var task;
        task = tasks[name];
        return gen3_asyncIfElse(task, function(continuation) {
            var gen16_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
            continuation = gen1_continuationOrDefault(arguments);
            return gen3_asyncIfElse(isFunctionAsynchronous(task.function), function(continuation) {
                var gen17_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                continuation = gen1_continuationOrDefault(arguments);
                return task.function(args, continuation);
            }, function(continuation) {
                var gen18_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                continuation = gen1_continuationOrDefault(arguments);
                return continuation(void 0, task.function(args));
            }, continuation);
        }, function(continuation) {
            var gen19_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
            continuation = gen1_continuationOrDefault(arguments);
            process.stderr.write("could not find task `" + name + "'");
            return continuation(void 0, process.exit(1));
        }, continuation);
    };
    displayTasks = function(tasks) {
        var tn;
        console.log("tasks:");
        console.log();
        for (tn in tasks) {
            (function(tn) {
                var task, description;
                if (tasks.hasOwnProperty(tn)) {
                    task = tasks[tn];
                    description = function() {
                        if (task.description) {
                            return ", " + task.description;
                        } else {
                            return "";
                        }
                    }();
                    console.log("    " + task.name + "" + description);
                    console.log();
                }
            })(tn);
        }
        return void 0;
    };
    exports.run = function(continuation) {
        var self = this;
        var gen20_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
        continuation = gen1_continuationOrDefault(arguments);
        return findQo(gen4_rethrowErrors(continuation, function(gen21_asyncResult) {
            var qo;
            qo = gen21_asyncResult;
            return gen3_asyncIfElse(qo, function(continuation) {
                var gen22_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                continuation = gen1_continuationOrDefault(arguments);
                var tasks, taskName;
                tasks = defineTasks();
                process.chdir(path.dirname(qo));
                require(qo);
                taskName = argv._.shift();
                return gen3_asyncIfElse(taskName, function(continuation) {
                    var gen23_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                    continuation = gen1_continuationOrDefault(arguments);
                    return runTaskFromWithArgs(taskName, tasks, parseArgs(), continuation);
                }, function(continuation) {
                    var gen24_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                    continuation = gen1_continuationOrDefault(arguments);
                    return continuation(void 0, displayTasks(tasks));
                }, continuation);
            }, function(continuation) {
                var gen25_arguments = Array.prototype.slice.call(arguments, 0, arguments.length - 1);
                continuation = gen1_continuationOrDefault(arguments);
                process.stderr.write("couldn't find `qo.pogo` in any parent directory");
                return continuation(void 0, process.exit(1));
            }, continuation);
        }));
    };
}).call(this);